/*
 *   gWX^Zp@QOOWNWAXt^ 78K0 }`eX^[PA_v^pvO  Ver.1.00
 *
 *   gWX^Zp@QOOXNSf  (C)Shibuta Fuminori
 *
 *   MPLAB IDE Ver.7.60, CC5X C Compiler Ver.3.3A
 *
 *@@@PIC16F648A
 *
 *@@@RA0: OUT, Volt+ Relay, Volt- Relay
 *@@@RA1: OUT, OSC+ Relay
 *@@@RA2: OUT, ADC
 *@@@RA3: OUT, 78K0 Reset
 *@@@RA4: NC.
 *@@@RA5: NC.
 *@@@RA6: OUT, Resistor+ Relay
 *@@@RA7: OUT, GND Relay
 *
 *@@@RB0: IN,  SW OSC. Select
 *@@@RB1: IN,  SW Volt Select
 *@@@RB2: IN,  SW Resistor Select
 *@@@RB3: IN,  SW Menu Select
 *@@@RB4: IN,  SW1 Original Equiv.
 *@@@RB5: IN,  SW2 Original Equiv.
 *@@@RB6: IN,  SW3 Original Equiv.
 *@@@RB7: NC.
 *
 */

#pragma chip PIC16F648A
// #include "../inc/int16CXX.H"
#pragma config WDTE=off, FOSC=4, BODEN=off	// FOSC:HS=EXTERNAL, 4:INT_GPIO

/*
#pragma origin 4
interrupt int_server( void )	// gpȂ
{
	int_save_registers
	if (T0IF) {
		TMR0 = 0;
		T0IF = 0;
	}
	if (INTF) {
		// INT interrupt
		INTF = 0;
	}
	if (RBIF) {
		// RB port change interrupt
		W = PORTB;
	}
	int_restore_registers
}
*/

void delay( uns16 cntr )				// x
{	uns16 i, j;

	for( i=0; i<cntr; i++ ){
		for( j=0; j<127; j++ );
	}
}

void Reset( void )						// 78K0 Zbg
{
	RA3 = 0;
	delay(20);
	RA3 = 1;
	delay(20);
}

void SW_Push( int SW_No, int cnt )		// IWiXCb`̉͋[, SW_No=( 1:SW1, 2:SW2, 3:SW3), cnt:
{	int i;

	if( 1 == SW_No ){
		for( i=0; i<cnt; i++ ){
			VRCON = 0xE5;
			delay(20);
			VRCON = 0xCF;
			delay(5);
		}
	}else if( 2 == SW_No ){
		for( i=0; i<cnt; i++ ){
			VRCON = 0xE1;
			delay(20);
			VRCON = 0xCF;
			delay(5);
		}
	}else if( 3 == SW_No ){
		for( i=0; i<cnt; i++ ){
			VRCON = 0xE0;
			delay(20);
			VRCON = 0xCF;
			delay(5);
		}
	}else{
		VRCON = 0xCF;
	}
}

int EERead( int ADR )					// EEPROM ̃f[^ǂݏo, ADR:AhX
{
	EEADR = ADR;
	RD = 1;
	return EEDATA;
}

int EEWrite( int WriteData, int ADR )	// EEPROM ւ̏, WriteData:݃f[^, ADR:ރAhX
{
	EEDATA = WriteData;
	EEADR = ADR;
	WREN = 1;
	EECON2 = 0x55;
	EECON2 = 0xAA;
	WR = 1;

	while( 1 != EEIF ) ;
	EEIF = 0;
	WREN = 0;

	if( EERead( ADR ) != WriteData ) return 1;
	else return 0;
}

void SW0( void )						// IVN
{
	Reset();
	SW_Push( 3, 1 );
}

void SW1( void )						// dvN
{
	Reset();
	SW_Push( 2, 2 );
	SW_Push( 3, 1 );
}

void SW2( void )						// RvN
{
	Reset();
	SW_Push( 2, 4 );
	SW_Push( 3, 1 );
}

void AllRelayOFF( void )				// S[nee
{
	RA0 = 0;
	RA1 = 0;
	RA6 = 0;
	RA7 = 0;
	delay( 100 );
}

void main( void )
{
	char MainMenu, cnt, i;

	cnt = 1;
	if( 1 == TO && 1 == PD ){
		clearRAM();
	}
	OPTION = 0b.10000000;

	TRISA = 0b.00000100;
	TRISB = 0b.01111111;

	VRCON = 0xCF;
	CMCON = 0b.111;

	RTIE = 0;
	EEIE = 1;
	PEIE = 0;
	RBIE = 0;
	GIE  = 1;

	delay(50);
	Reset();
	delay(20);

	if( 0 == EERead(0)){				// dfOԂ̍Č
		AllRelayOFF();
		RA1 = 1;
		RA7 = 1;
		delay( 80 );
		SW0();							// IVN
		i = 1;
		while( 4 != EERead(i) ){
			 if( 0 == EERead (i) ){
				VRCON = 0xE5;
				delay(20);
				VRCON = 0xCF;
				delay(10);
			}else if( 1 == EERead(i) ){
				VRCON = 0xE1;
				delay(20);
				VRCON = 0xCF;
				delay(10);
			}else if( 2 == EERead(i) ){
				VRCON = 0xE0;
				delay(20);
				VRCON = 0xCF;
				delay(10);
			}
			i++;
			if( 21 < i ) break;
		}
	}else if( 1 == EERead(0) ){
		AllRelayOFF();
		RA0 = 1;
		delay( 50 );
		SW1();							// dvN
	}else if( 2 == EERead(0) ){
		AllRelayOFF();
		RA6 = 1;
		RA7 = 1;
		delay( 50 );
		SW2();							// RvN
	}else if( 3 == EERead(0) ){
		Reset();
		AllRelayOFF();
	}else{
		EEWrite( 3, 0 );
	}
	delay(20);

	while( 1 ){
		if( 0 == RB0 ){					// OSCpXCb` 
			AllRelayOFF();
			RA1 = 1;
			RA7 = 1;
			delay( 70 );
			SW0();							
			EEWrite( 0, 0 );
			MainMenu = 1;
			cnt = 1;
		}else if( 0 == RB1 ){			// dvpXCb`
			AllRelayOFF();
			RA0 = 1;
			delay( 70 );
			SW1();
			EEWrite( 1, 0 );
			MainMenu = 2;
		}else if( 0 == RB2 ){			// RvpXCb`
			AllRelayOFF();
			RA6 = 1;
			RA7 = 1;
			delay( 70 );
			SW2();
			EEWrite( 2, 0 );
			MainMenu = 3;
		}else if( 0 == RB3 ){			// j[pXCb`
			AllRelayOFF();
			Reset();
			EEWrite( 3, 0 );
		}else if( 0 == RB4 ){			// IWiSW1͋[
			SW_Push( 1, 1 );
			delay( 70 );
			if( 1 == MainMenu ){
				EEWrite( 0, cnt );
				cnt++;
				EEWrite( 4, cnt );
			}
		}else if( 0 == RB5 ){			// IWiSW2͋[
			SW_Push( 2, 1 );
			delay( 70 );
			if( 1 == MainMenu ){
				EEWrite( 1, cnt );
				cnt++;
				EEWrite( 4, cnt );
			}
		}else if( 0 == RB6 ){			// IWiSW3͋[
			SW_Push( 3, 1 );
			delay( 70 );
			if( 1 == MainMenu ){
				EEWrite( 2, cnt );
				cnt++;
				EEWrite( 4, cnt );
			}
		}else{
			VRCON = 0xCF;
		}
		delay( 10 );
		if( cnt > 20 ) cnt = 20;
	}
}
